org.apache.sis.metadata.iso.citation

## Class DefaultTelephone

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultTelephone

- All Implemented Interfaces:
    Serializable, Cloneable, Emptiable, LenientComparable, IdentifiedObject, Telephone

      public class DefaultTelephone
      extends ISOMetadata
      implements Telephone

  Telephone numbers for contacting the responsible individual or organization. The following property is mandatory in a well-formed metadata according ISO 19115:
  `CI_Telephone` `└─number……` Telephone number by which individuals can contact responsible organisation or individual.
  Differences between versions 2003 and 2014 of ISO 19115
  For any contact having more than one telephone number, the way to organize the information changed significantly between the two versions of ISO standard:
  - In ISO 19115:2003, each `Contact` had only one `Telephone` instance, but that instance could have an arbitrary amount of "voice" and "facsimile" numbers. The methods (now deprecated) were `DefaultContact​.getPhone()`, `getVoices()` and `getFacsimiles()`.
  - In ISO 19115:2014, each `Contact` has an arbitrary amount of `Telephone` instances, and each telephone has exactly one number. The new methods are `DefaultContact​.getPhones()`, `getNumber()` and `getNumberType()`.
  Limitations
  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.5
  See Also:
    `DefaultContact​.getPhones()`, Serialized Form

  Defined in the `sis-metadata` module

- - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultTelephone()` Constructs a default telephone.
    `DefaultTelephone(Telephone object)` Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultTelephone` | `castOrCopy(Telephone object)` Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Collection<String>` | `getFacsimiles()` Deprecated. As of ISO 19115:2014, replaced by a number code `TelephoneType​.FACSIMILE`.
    `String` | `getNumber()` Returns the telephone number by which individuals can contact responsible organization or individual.
    `CodeList<?>` | `getNumberType()` Returns the type of telephone number, or `null` if none.
    `Collection<String>` | `getVoices()` Deprecated. As of ISO 19115:2014, replaced by a number with `TelephoneType​.VOICE`.
    `void` | `setFacsimiles(Collection<? extends String> newValues)` Deprecated. As of ISO 19115:2014, replaced by a number with `TelephoneType​.FACSIMILE`.
    `void` | `setNumber(String newValue)` Sets the telephone number by which individuals can contact responsible organization or individual.
    `void` | `setNumberType(CodeList<?> newValue)` Sets the type of telephone number.
    `void` | `setVoices(Collection<? extends String> newValues)` Deprecated. As of ISO 19115:2014, replaced by a number code `TelephoneType​.VOICE`.

    - ### Methods inherited from class ISOMetadata

      `freeze, getIdentifierMap, getIdentifiers, getStandard`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, clone, collectionType, copyCollection, copyList, copySet, isModifiable, nonNullCollection, nonNullList, nonNullSet, singleton, unmodifiable, writeCollection, writeList, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultTelephone

          public DefaultTelephone()

      Constructs a default telephone.

    - #### DefaultTelephone

          public DefaultTelephone(Telephone object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(Telephone)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultTelephone castOrCopy(Telephone object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultTelephone`, then it is returned unchanged.
      - Otherwise a new `DefaultTelephone` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getNumber

          @UML(identifier="number",
               obligation=MANDATORY,
               specification=ISO_19115)
          public String getNumber()

      Returns the telephone number by which individuals can contact responsible organization or individual.
      Returns:
        telephone number by which individuals can contact responsible organization or individual.
      Since:
        0.5

    - #### setNumber

          public void setNumber(String newValue)

      Sets the telephone number by which individuals can contact responsible organization or individual.
      Parameters:
        `newValue` - the new telephone number by which individuals can contact responsible organization or individual.
      Since:
        0.5

    - #### getNumberType

          @UML(identifier="numberType",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public CodeList<?> getNumberType()

      Returns the type of telephone number, or `null` if none. If non-null, the type can be `"VOICE"`, `"FACSIMILE"` or `"SMS"`.
      Upcoming API change — specialization
      The return type will be changed to the `TelephoneType` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        type of telephone number, or `null` if none.
      Since:
        0.5

    - #### setNumberType

          public void setNumberType(CodeList<?> newValue)

      Sets the type of telephone number. If non-null, the type can only be `"VOICE"`, `"FACSIMILE"` or `"SMS"`.
      Upcoming API change — specialization
      The argument type will be changed to the `TelephoneType` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1). In the meantime, users can define their own code list class as below:

          final class UnsupportedCodeList extends CodeList<UnsupportedCodeList> {
              private static final List<UnsupportedCodeList> VALUES = new ArrayList<UnsupportedCodeList>();

              // Need to declare at least one code list element.
              public static final UnsupportedCodeList MY_CODE_LIST = new UnsupportedCodeList("MY_CODE_LIST");

              private UnsupportedCodeList(String name) {
                  super(name, VALUES);
              }

              public static UnsupportedCodeList valueOf(String code) {
                  return valueOf(UnsupportedCodeList.class, code);
              }

              @Override
              public UnsupportedCodeList[] family() {
                  synchronized (VALUES) {
                      return VALUES.toArray(new UnsupportedCodeList[VALUES.size()]);
                  }
              }
          }

      Parameters:
        `newValue` - the new type of telephone number.
      Since:
        0.5

    - #### getVoices

          @Deprecated
          public final Collection<String> getVoices()

      Deprecated. As of ISO 19115:2014, replaced by a number with `TelephoneType​.VOICE`.
      Returns the telephone numbers by which individuals can speak to the responsible organization or individual. This method searches in the contact phones, if the contact that own this phone is known.
      Specified by:
        `getVoices` in interface `Telephone`
      Returns:
        telephone numbers by which individuals can speak to the responsible organization or individual.

    - #### setVoices

          @Deprecated
          public void setVoices(Collection<? extends String> newValues)

      Deprecated. As of ISO 19115:2014, replaced by a number code `TelephoneType​.VOICE`.
      Sets the telephone numbers by which individuals can speak to the responsible organization or individual. This method writes in the contact phones, if the contact that own this phone is known.
      Parameters:
        `newValues` - the new telephone numbers, or `null` if none.

    - #### getFacsimiles

          @Deprecated
          public final Collection<String> getFacsimiles()

      Deprecated. As of ISO 19115:2014, replaced by a number code `TelephoneType​.FACSIMILE`.
      Returns the telephone numbers of a facsimile machine for the responsible organization or individual. This method searches in the contact phones, if the contact that own this phone is known.
      Specified by:
        `getFacsimiles` in interface `Telephone`
      Returns:
        telephone numbers of a facsimile machine for the responsible organization or individual.

    - #### setFacsimiles

          @Deprecated
          public void setFacsimiles(Collection<? extends String> newValues)

      Deprecated. As of ISO 19115:2014, replaced by a number with `TelephoneType​.FACSIMILE`.
      Sets the telephone number of a facsimile machine for the responsible organization or individual. This method writes in the contact phones, if the contact that own this phone is known.
      Parameters:
        `newValues` - the new telephone number, or `null` if none.

Copyright © 2010–2017 The Apache Software Foundation. All rights reserved.